image: node:latest
stages:
  - transpilation
  - test
  - documentation
  - release

cache:
  paths:
    - node_modules/

before_script:
  - npm install
  - npm prune

typescript:
  stage: transpilation
  script:
    - npx tsc
    - cp package.json dist
  artifacts:
    paths:
      - dist
    expire_in: 2 hours
    
pages:
  stage: documentation
  only:
    - master
  script:
    - npx typedoc --out public --mode file src
  artifacts:
    name: factlib_docs
    paths:
      - public/
    expire_in: 1 week

deploy_npm:
  stage: release
  only:
    - tags
  script:
    - rm .npmrc
    - mv npmrc-ci .npmrc
    - npm publish dist
    
include:
  - template: Dependency-Scanning.gitlab-ci.yml

